SystemOrganization addCategory: 'Database-Abstraction-LayerGemStone'!

Object subclass: #WriteHistoryFrame
	instanceVariableNames: 'next cache operations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Database-Abstraction-LayerGemStone'!

!WriteHistoryFrame classSide methodsFor: 'instance creation' stamp: 'AndyKellens 08/08/2010 10:46'!
new 
	^super new initialize! !

!WriteHistoryFrame methodsFor: 'adding' stamp: 'JohanBrichau 07/14/2011 09:55'!
addObject: anObject
	cache add: anObject asOop! !

!WriteHistoryFrame methodsFor: 'adding' stamp: 'JohanBrichau 07/14/2011 09:55'!
addObject: anObject operation: aSymbol
	cache add: anObject asOop.
	(operations at: anObject asOop ifAbsentPut:[Set new]) add: aSymbol! !

!WriteHistoryFrame methodsFor: 'querying' stamp: 'JohanBrichau 07/14/2011 09:57'!
conflictWith: aWriteCache
	| objects  |
	objects := (cache intersection: (aWriteCache objectOops)).
	objects 
		ifEmpty:[^false].
	objects do:[:obj |
		|myOp theirOp |
		myOp := operations at: obj.
		theirOp := aWriteCache operationsForObject: obj.
		(myOp intersection: theirOp) isEmpty ifFalse:[ ^true]].
	^false! !

!WriteHistoryFrame methodsFor: 'querying' stamp: 'JohanBrichau 07/14/2011 17:18'!
describeConflictWith: aWriteCache
	| objects conflicts stream |
	stream := WriteStream on: String new.
	objects := (cache intersection: (aWriteCache objectOops)).
	objects 
		ifEmpty:[^'No conflicting objects found'].
	objects do:[:obj |
		|myOp theirOp |
		myOp := operations at: obj.
		theirOp := aWriteCache operationsForObject: obj.
		(conflicts := myOp intersection: theirOp) isEmpty ifFalse:[
			stream nextPutAll: 'oop:',obj greaseString,' operations: '.
			conflicts do:[:c | stream nextPutAll: c greaseString] separatedBy: [stream nextPut: $,].
			stream cr]].
	^ stream contents, ' in ',aWriteCache asOop asString,' and ',self asOop asString.! !

!WriteHistoryFrame methodsFor: 'initialize-release' stamp: 'AndyKellens 02/16/2011 20:57'!
initialize
	super initialize.
	cache := IdentitySet new.
	operations := IdentityDictionary new! !

!WriteHistoryFrame methodsFor: 'accessing' stamp: 'AndyKellens 08/14/2010 11:17'!
next
	^next! !

!WriteHistoryFrame methodsFor: 'accessing' stamp: 'AndyKellens 08/14/2010 10:16'!
next: aFrame
	next := aFrame! !

!WriteHistoryFrame methodsFor: 'querying' stamp: 'JohanBrichau 07/14/2011 09:56'!
objectOops
	^cache! !

!WriteHistoryFrame methodsFor: 'initialize-release' stamp: 'AndyKellens 02/16/2011 20:49'!
operationsForObject: anObject
	^operations at: anObject! !

Dictionary subclass: #DALGsDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Database-Abstraction-LayerGemStone'!

!DALGsDictionary methodsFor: 'Adding' stamp: 'JohanBrichau 03/05/2011 15:06'!
add: anAssociation
	self markAsChanged.
	^super add: anAssociation! !

!DALGsDictionary methodsFor: 'Adding' stamp: 'JohanBrichau 03/05/2011 15:06'!
at: aKey put: aValue
	self markAsChanged.
	^super at: aKey put: aValue! !

!DALGsDictionary methodsFor: 'Removing' stamp: 'JohanBrichau 03/05/2011 15:06'!
removeAssociation: anAssociation otherwise: defaultValue
	self markAsChanged.
	^super removeAssociation: anAssociation otherwise: defaultValue! !

!DALGsDictionary methodsFor: 'Removing' stamp: 'JohanBrichau 03/05/2011 15:06'!
removeKey: aKey ifAbsent: aBlock
	self markAsChanged.
	^super removeKey: aKey ifAbsent: aBlock! !

!DALGsDictionary methodsFor: 'Removing' stamp: 'JohanBrichau 03/05/2011 15:06'!
removeKey: aKey otherwise: defaultValue
	self markAsChanged.
	^super removeKey: aKey otherwise: defaultValue! !

!DALGsDictionary methodsFor: 'Private' stamp: 'JohanBrichau 03/05/2011 15:06'!
speciesForCollect
	^Dictionary! !

!DALGsDictionary methodsFor: 'Private' stamp: 'JohanBrichau 03/05/2011 15:06'!
speciesForSelect
	^Dictionary! !

OrderedCollection subclass: #DALGsOrderedCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Database-Abstraction-LayerGemStone'!

!DALGsOrderedCollection methodsFor: 'Adding' stamp: 'JohanBrichau 03/05/2011 15:06'!
_addAllFromNsc: aBag
	self markAsChanged.
	^super _addAllFromNsc: aBag! !

!DALGsOrderedCollection methodsFor: 'Adding' stamp: 'JohanBrichau 03/05/2011 15:06'!
add: newObject
	self markAsChanged.
	^super add: newObject! !

!DALGsOrderedCollection methodsFor: 'Adding' stamp: 'JohanBrichau 03/05/2011 15:06'!
addLast: newObject
	self markAsChanged.
	^super addLast: newObject! !

!DALGsOrderedCollection methodsFor: 'Adding' stamp: 'JohanBrichau 03/05/2011 15:06'!
insertAll: aCollection at: anIndex
	self markAsChanged.
	^super insertAll: aCollection at: anIndex! !

!DALGsOrderedCollection methodsFor: 'Removing' stamp: 'JohanBrichau 03/05/2011 15:06'!
removeFrom: startIndex to: stopIndex
	self markAsChanged.
	^super removeFrom: startIndex to: stopIndex! !

!DALGsOrderedCollection methodsFor: 'Removing' stamp: 'JohanBrichau 03/05/2011 15:06'!
removeLast
	self markAsChanged.
	^super removeLast! !

!DALGsOrderedCollection methodsFor: 'Private' stamp: 'JohanBrichau 03/05/2011 15:06'!
speciesForCollect
	^OrderedCollection! !

!DALGsOrderedCollection methodsFor: 'Private' stamp: 'JohanBrichau 03/05/2011 15:06'!
speciesForSelect
	^OrderedCollection! !

!GRGemStonePlatform methodsFor: '*Database-Abstraction-LayerGemStone' stamp: 'JohanBrichau 05/08/2011 10:31'!
resetDALTxState
	System _sessionStateAt: 20 put: nil.! !

!GRGemStonePlatform methodsFor: '*Database-Abstraction-LayerGemStone' stamp: 'JohanBrichau 05/08/2011 10:32'!
seasideProcessRequest: aNativeRequest adaptor: adaptor resultBlock: resultBlock
	
	| result |
	"Adaptation of the original method: reset the DAL transaction state when entering a request"
	self resetDALTxState.
	[ | retryCount result count |
		retryCount := self retryCount.
		count := 1.
		retryCount timesRepeat: [
			"(System _sessionStateAt: 20)
				 ifNotNil:[self 
					saveLogEntry: (WAObjectLogEntry warn: 'Retrying a semantic conflict' request: aNativeRequest object: (System _sessionStateAt:20))  
					shouldCommit: false]."
			(result := self
				seasideProcessRequestWithRetry: aNativeRequest 
				resultBlock: resultBlock) ~~ nil
					ifTrue: [ ^result ].
				System _sessionCacheStatAt: 2 put: ((System _sessionCacheStatAt: 2) + 1). "requests retried"
				(Delay forMilliseconds: self retryDelay * count) wait.
				count := count * 10 ].
		"exceeded retry limit"
		^adaptor internalServerErrorMessage: 'Too many retries: ', (retryCount+1) printString ] 
			on: Error
			do: [:ex |
				self doAbortTransaction.
				result := adaptor internalServerErrorMessage: ex description.
				"Do an explicit return. Because of the abort above, the default action for an exception (resume) is set. see bug39246."
				ex return: nil ].
	^result! !

!GRGemStonePlatform methodsFor: '*Database-Abstraction-LayerGemStone' stamp: 'JohanBrichau 07/14/2011 22:30'!
seasideProcessRequestWithRetry: aNativeRequest resultBlock: resultBlock
	"answer nil to retry request"

	| result retryRequest retryException lockCode|
	self transactionMutex critical: [
		System inTransaction
			ifTrue:[ self doAbortTransaction ]
			ifFalse: [ self doBeginTransaction ].
		retryRequest := false.
		System _sessionCacheStatAt: 0 put: ((System _sessionCacheStatAt: 0) + 1). "requests received"
		"Clear the DAL writebarrier - it will gather the written objects"
		DALSessionGemStone clearBarrier; deactivateWriteBarrier.
		[result := (resultBlock value: aNativeRequest)]
				on: (WARetryHttpRequest, SafelyPerformBlockRequiringAbort, DALGsSemanticConflictException)
				do: [:ex |
					
					retryRequest := true.
					retryException := ex ].
		retryRequest
				ifTrue: [
					(retryException isKindOf: DALGsSemanticConflictException)
							ifTrue:[
								"Abort the transaction"
								self doAbortTransaction.
								self 
									saveLogEntry: (WAObjectLogEntry trace: 'Semantic conflict - retrying!!' request: aNativeRequest object: retryException messageText) 
									shouldCommit: true.
								System _sessionCacheStatAt: 3 put: ((System _sessionCacheStatAt: 3) + 1). "semantic conflicts"
								^nil "Retry to process the request in order to execute the failure block"].
					(retryException isKindOf: SafelyPerformBlockRequiringAbort)
							ifTrue: [
								"Abort and start a transaction"
								self doBeginTransaction.
								retryException block value: true.
								"block is expected to do it's own commit, but make sure we've left transaction mode"
								self doAbortTransaction ]
							ifFalse: [
								"lock not acquired - unwind the stack to this point and leave transaction mode"
								self doAbortTransaction.
								self 
									saveLogEntry: (WAObjectLogEntry trace: retryException logMessage request: aNativeRequest object: retryException description) 
									shouldCommit: true ].
								^nil "retry request" ].
		lockCode := System waitForApplicationWriteLock: DALSessionGemStone queue: 1 autoRelease: true.
		lockCode = 1 ifFalse:[
				self doAbortTransaction.
				self 
					saveLogEntry: (WAObjectLogEntry warn: 'DAL history lock error code:' request: aNativeRequest object: lockCode)  
					shouldCommit: true.
				^ nil].
		System continueTransaction
			ifTrue: [	"Commit the write barrier to the write history for semantic conflict checking - but make sure it does not fail by locking"
					DALSessionGemStone commitFrame.
					self doCommitTransaction.]
			ifFalse: [ | conflicts | 
				conflicts := System transactionConflicts.
				self doAbortTransaction.
				self 
					saveLogEntry: (WAObjectLogEntry warn: 'Commit failure - retrying' request: aNativeRequest object: conflicts)  
					shouldCommit: true.
				^nil "retry request"].
		System _sessionCacheStatAt: 1 put: ((System _sessionCacheStatAt: 1) + 1). "requests processed (successful)"].
	
	^result! !

DALSession subclass: #DALSessionGemStone
	instanceVariableNames: 'transactionLevel inTransaction writeHistoryIndex rootKey'
	classVariableNames: 'writeHistory'
	poolDictionaries: ''
	category: 'Database-Abstraction-LayerGemStone'!

!DALSessionGemStone classSide methodsFor: 'write barrier' stamp: 'JohanBrichau 07/14/2011 13:35'!
activateWriteBarrier
	^ System _sessionStateAt: 22 put: true! !

!DALSessionGemStone classSide methodsFor: 'transaction support' stamp: 'JohanBrichau 07/14/2011 13:36'!
clearBarrier
	"Empty the write barrier, loosing the recorded history"
	self writeBarrier: WriteHistoryFrame new.! !

!DALSessionGemStone classSide methodsFor: 'transaction support' stamp: 'JohanBrichau 07/14/2011 22:36'!
commitFrame
	"Commiting the history frame to the history list (only when there is something to add)"
	self writeBarrier objectOops isEmpty 
		ifFalse:[	"Transcript show: 'commit frame ',self writeBarrier asOop asString,' as next of ',writeHistory asOop asString." 
				writeHistory next: self writeBarrier.
				writeHistory := self writeBarrier].
	
	self clearBarrier.! !

!DALSessionGemStone classSide methodsFor: 'transaction support' stamp: 'JohanBrichau 07/14/2011 11:37'!
conflictFrameOrNilFrom: frame
	| next |
	"Check from the frame all the way to the end for conflicting changes"
	
	next := frame next.
	[next notNil] 
		whileTrue:[
			"If a commit conflict occurred, then return the conflicting frame"
			(next conflictWith: self writeBarrier) 
				ifTrue:[^next].
			next := next next].
	"If we get to the top without commit conflicts, return nil"
	^nil! !

!DALSessionGemStone classSide methodsFor: 'factory methods' stamp: 'JohanBrichau 03/05/2011 15:06'!
createDictionary
	^DALGsDictionary new! !

!DALSessionGemStone classSide methodsFor: 'factory methods' stamp: 'JohanBrichau 03/05/2011 15:06'!
createOrderedCollection
	^DALGsOrderedCollection new! !

!DALSessionGemStone classSide methodsFor: 'factory methods' stamp: 'AndyKellens 12/17/2010 20:37'!
createRcDictionary
	^Dictionary new! !

!DALSessionGemStone classSide methodsFor: 'factory methods' stamp: 'AndyKellens 12/17/2010 20:37'!
createRcOrderedCollection
	^OrderedCollection new! !

!DALSessionGemStone classSide methodsFor: 'factory methods' stamp: 'AndyKellens 12/17/2010 20:37'!
createRcSet
	^Set new! !

!DALSessionGemStone classSide methodsFor: 'factory methods' stamp: 'JohanBrichau 03/05/2011 15:07'!
createSet
	^DALGsSet new! !

!DALSessionGemStone classSide methodsFor: 'factory methods' stamp: 'JohanBrichau 04/21/2011 15:47'!
createVersionStamp
	^RcCounter new! !

!DALSessionGemStone classSide methodsFor: 'history' stamp: 'JohanBrichau 07/14/2011 14:06'!
currentHistoryPointer
	^writeHistory! !

!DALSessionGemStone classSide methodsFor: 'factory methods' stamp: 'AndyKellens 04/13/2011 18:53'!
databaseException
	^DALGsFailureBlockException! !

!DALSessionGemStone classSide methodsFor: 'write barrier' stamp: 'JohanBrichau 07/14/2011 13:35'!
deactivateWriteBarrier
	^ System _sessionStateAt: 22 put: false! !

!DALSessionGemStone classSide methodsFor: 'transaction support' stamp: 'JohanBrichau 05/19/2011 15:56'!
initialize
	super initialize.
	self initializeHistory.! !

!DALSessionGemStone classSide methodsFor: 'history' stamp: 'JohanBrichau 07/14/2011 14:06'!
initializeHistory
	writeHistory := WriteHistoryFrame new! !

!DALSessionGemStone classSide methodsFor: 'transaction support' stamp: 'JohanBrichau 07/14/2011 22:05'!
markObject: anObject operation: aSymbol
	self writeBarrierIsActive ifTrue:[
		"Transcript show: 'Putting ',anObject asOop asString,'#',aSymbol asString,' in ',self writeBarrier asOop asString."
		self writeBarrier addObject: anObject operation: aSymbol]! !

!DALSessionGemStone classSide methodsFor: 'write barrier' stamp: 'JohanBrichau 05/19/2011 15:52'!
writeBarrier
	^ System _sessionStateAt: 21! !

!DALSessionGemStone classSide methodsFor: 'write barrier' stamp: 'JohanBrichau 07/14/2011 17:15'!
writeBarrier: aHistoryFrame
	"Transcript show: 'setting barrier ',aHistoryFrame asOop asString."
	^ System _sessionStateAt: 21 put: aHistoryFrame! !

!DALSessionGemStone classSide methodsFor: 'write barrier' stamp: 'JohanBrichau 07/14/2011 13:38'!
writeBarrierIsActive
	^ System _sessionStateAt: 22! !

!DALSessionGemStone methodsFor: 'private' stamp: 'JohanBrichau 07/14/2011 22:29'!
bringUpToDate
	"Transcript show: 'doing a bring up to date from ',writeHistoryIndex asOop asString, ' to ', self class currentHistoryPointer asOop asString.
	writeHistoryIndex := self class currentHistoryPointer."! !

!DALSessionGemStone methodsFor: 'public' stamp: 'AndyKellens 12/17/2010 20:47'!
commit
	| result |
	result := System commitTransaction.
	result 
		ifTrue:[System beginTransaction].
	^result
								! !

!DALSessionGemStone methodsFor: 'public' stamp: 'AndyKellens 12/17/2010 20:48'!
disconnect
	! !

!DALSessionGemStone methodsFor: 'public' stamp: 'JohanBrichau 07/14/2011 22:34'!
executeAsTransaction: aBlock
	|conflictFrame|
	transactionLevel = 0 
		ifTrue:[
			"Check whether this transaction is the result of a retry at the level of seaside"
			(self retryOfFailureForBlock: aBlock)
				ifTrue:["If so, notify the higher level that we should execute the failure block" self raiseFailureException].
			"Transcript show: 'starting tx on ',self class writeBarrier asOop asString, ' with my history at ',writeHistoryIndex asOop asString."
			self class activateWriteBarrier].
	transactionLevel := transactionLevel + 1.
	inTransaction := true.
	[aBlock value.  transactionLevel := transactionLevel - 1]
		on:Error do:[:exp | 
			transactionLevel := 0. inTransaction := false.
			exp signal].
	transactionLevel = 0 ifTrue:[
			inTransaction := false.
			self class deactivateWriteBarrier.
			(conflictFrame := self class conflictFrameOrNilFrom: writeHistoryIndex)
				ifNil:[
					"We can proceed with committing"
					"self class commitFrame."
					"Transcript show: 'stopping tx on ',self class writeBarrier asOop asString."
					writeHistoryIndex := self class writeBarrier]
				ifNotNil:[
					"Raise an exception indicating a semantic conflict"
					self raiseSemanticConflictExceptionForBlock: aBlock message: (writeHistoryIndex describeConflictWith: conflictFrame)]]! !

!DALSessionGemStone methodsFor: 'private' stamp: 'AndyKellens 12/17/2010 20:51'!
increaseUniqueIdentifier
	^System persistentCounterAt: 1 incrementBy:1! !

!DALSessionGemStone methodsFor: 'initialization' stamp: 'JohanBrichau 05/19/2011 16:02'!
initializeWithDAO: aDAO
	super initializeWithDAO: aDAO.
	self class clearBarrier.
	transactionLevel := 0.
	inTransaction := false.
	rootKey := aDAO rootKey.
	writeHistoryIndex := self class currentHistoryPointer! !

!DALSessionGemStone methodsFor: 'transaction handling' stamp: 'JohanBrichau 04/14/2011 13:22'!
raiseFailureException
	"Empty the state again"
	System _sessionStateAt:20 put: nil. 
	"Update the current history pointer index"
	writeHistoryIndex := self class currentHistoryPointer.
	"Raise the exception"
	self class databaseException signal! !

!DALSessionGemStone methodsFor: 'transaction handling' stamp: 'JohanBrichau 05/14/2011 20:42'!
raiseSemanticConflictExceptionForBlock: aBlock message: aString
	(System _sessionStateAt: 20 put: aBlock).
	DALGsSemanticConflictException signal: aString! !

!DALSessionGemStone methodsFor: 'private' stamp: 'JohanBrichau 05/24/2011 11:26'!
registrationOperation: aBlock forObject: anObject
	| theID |
	"Check if the object is actually reregistered"
	"If this is the case, then reuse the old ID"
	theID := (anObject uniqueIdentifier isNilID and:[anObject uniqueIdentifier oldID notNil]) 						
					ifTrue:[anObject uniqueIdentifier oldID] 
					ifFalse:[anObject asOop].
	inTransaction ifTrue:
			[anObject uniqueIdentifier: theID. 
			 self putObjectInHash: anObject.
			aBlock value]
		ifFalse:
			[
			anObject uniqueIdentifier: theID.
			self putObjectInHash: anObject.
			aBlock value.
			"self commit"]! !

!DALSessionGemStone methodsFor: 'transaction handling' stamp: 'AndyKellens 04/13/2011 19:32'!
retryOfFailureForBlock: aBlock
	| value |
	value := (System _sessionStateAt: 20).
	^(value notNil and:[value _sourceString = (aBlock _sourceString)]) ! !

!DALSessionGemStone methodsFor: 'public' stamp: 'AndyKellens 12/17/2010 20:48'!
rollback
	System abortTransaction.
	System beginTransaction.
	writeHistoryIndex := self class currentHistoryPointer.! !

!DALSessionGemStone methodsFor: 'public' stamp: 'JohanBrichau 03/06/2011 10:05'!
root 
	^UserGlobals at: rootKey! !

!DALSessionGemStone methodsFor: 'public' stamp: 'JohanBrichau 03/06/2011 10:05'!
root: anObject
	^UserGlobals at: rootKey put: anObject! !

!DALSessionGemStone methodsFor: 'private' stamp: 'JohanBrichau 04/14/2011 13:03'!
unregistrationOperation: aBlock forObject: anObject
	| newID |
	anObject uniqueIdentifier isNilID 
		ifTrue:[newID := anObject uniqueIdentifier]
		ifFalse:[
		newID := NPNilID new.
		newID oldID: (anObject uniqueIdentifier)].
	inTransaction 
		ifTrue: [ 
				aBlock value. 
				self removeObjectFromHash: anObject. 
				anObject uniqueIdentifier: newID]
		ifFalse: [ 
				aBlock value. 
				self removeObjectFromHash: anObject. 
				anObject uniqueIdentifier: newID.
				"self commit"]! !

!DALSessionGemStone methodsFor: 'public' stamp: 'AndyKellens 02/17/2011 18:54'!
withRetryOperation: aBlock
	^self executeAsTransaction: aBlock! !

DALSessionGemStone subclass: #DALSessionGemStoneForTesting
	instanceVariableNames: 'transactionShouldFail'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Database-Abstraction-LayerGemStone'!

!DALSessionGemStoneForTesting methodsFor: 'public' stamp: 'JohanBrichau 07/02/2011 11:06'!
executeAsTransaction: aBlock
	"To make it possible to test transaction, the unit test can set a
	switch on the testing DAO that makes the next transaction fail. If
	that bit is set, an Exception is raised, else the block is executed
	and its value returned."
	transactionShouldFail
		ifTrue: [self class databaseException signal.]
		ifFalse: [ ^ super executeAsTransaction: aBlock].
	! !

!DALSessionGemStoneForTesting methodsFor: 'private' stamp: 'JohanBrichau 07/02/2011 11:04'!
failTransaction 
	transactionShouldFail := true! !

!DALSessionGemStoneForTesting methodsFor: 'initialization' stamp: 'JohanBrichau 07/02/2011 11:12'!
initializeWithDAO: aDAO 
	super initializeWithDAO: aDAO.
	transactionShouldFail := false.! !

!DALSessionGemStoneForTesting methodsFor: 'private' stamp: 'JohanBrichau 07/02/2011 11:04'!
succeedTransaction 
	transactionShouldFail := false! !

Set subclass: #DALGsSet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Database-Abstraction-LayerGemStone'!

!DALGsSet methodsFor: 'Adding' stamp: 'JohanBrichau 03/05/2011 15:06'!
add: newObject
	self markAsChanged.
	^super add: newObject! !

!DALGsSet methodsFor: 'Removing' stamp: 'JohanBrichau 03/05/2011 15:06'!
remove: anObject ifAbsent: anExceptionBlock
	self markAsChanged.
	^super remove: anObject ifAbsent: anExceptionBlock! !

!DALGsSet methodsFor: 'Removing' stamp: 'JohanBrichau 03/05/2011 15:06'!
removeAll: aCollection
	self markAsChanged.
	^super removeAll: aCollection! !

!DALGsSet methodsFor: 'Private' stamp: 'JohanBrichau 03/05/2011 15:06'!
speciesForCollect
	^Set! !

!DALGsSet methodsFor: 'Private' stamp: 'JohanBrichau 03/05/2011 15:06'!
speciesForSelect
	^Set! !

!DALObjectIDCounter methodsFor: '*Database-Abstraction-LayerGemStone' stamp: 'JohanBrichau 03/06/2011 09:00'!
markAsChanged
	DALSessionGemStone markObject: self operation: #Counter! !

!Collection methodsFor: '*Database-Abstraction-LayerGemStone' stamp: 'JohanBrichau 03/05/2011 15:22'!
markAsChanged
	DALSessionGemStone markObject: self operation: #Collection! !

ExceptionA subclass: #DALGsFailureBlockException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Database-Abstraction-LayerGemStone'!

ExceptionA subclass: #DALGsSemanticConflictException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Database-Abstraction-LayerGemStone'!
DALSessionGemStone initialize!
